=== debian/changelog ===
i2pd (2.45.1-1) unstable; urgency=medium

  * New upstream release
    + Fix FTBFS on riscv64 (Closes: #1026938)
  * Bump Standards-Version to 4.6.2

 -- Yangfl <mmyangfl@gmail.com>  Fri, 20 Jan 2023 18:41:30 +0800

i2pd (2.43.0-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.6.1

 -- Yangfl <mmyangfl@gmail.com>  Sun, 23 Oct 2022 17:38:49 +0800

i2pd (2.41.0-1) unstable; urgency=medium

  * New upstream release
    + Fix FTBFS with OpenSSL 3.0 (Closes: #1006243)
    + Fix crash due to SSU2 (Closes: #1008087)

 -- Yangfl <mmyangfl@gmail.com>  Sun, 03 Apr 2022 14:22:27 +0800
