=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1


export DEB_BUILD_MAINT_OPTIONS = hardening=+all


include /usr/share/dpkg/architecture.mk

export DEB_CXXFLAGS_MAINT_APPEND  = -Wall -pedantic -O3

ifneq ($(filter amd64 x32,$(DEB_HOST_ARCH)),)
  export DEB_CXXFLAGS_MAINT_APPEND  += -D__AES__ -D__AVX__
endif

export DEB_LDFLAGS_MAINT_APPEND =


%:
	dh $@ --buildsystem=cmake

.PHONY: build
build:
	dh $@ --buildsystem=cmake

override_dh_auto_clean:
	dh_auto_clean --buildsystem=cmake --sourcedirectory=build/

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake --sourcedirectory=build/ -- \
		-DWITH_UPNP=ON -DWITH_WEBSOCKETS=ON

execute_after_dh_install:
	dh_apparmor -p i2pd --profile-name=usr.sbin.i2pd
