## i2pd 2.51.0

=== debian/changelog ===
i2pd (2.51.0-1) unstable; urgency=medium

  * New upstream release
    * Fix FTBFS on armel (Closes: #1060787)
  * Link /usr/sbin/i2pd to /usr/bin/i2pd (Closes: #1064793)
  * Bump Standards-Version to 4.7.0

 -- Yangfl <mmyangfl@gmail.com>  Fri, 12 Apr 2024 13:27:08 +0800
